"""Use Pyrex "for" construct"""

from math import sqrt, ceil
from operator import add

def _calculate_factors(int x):
    cdef int sqrt_x, i
    
    factors = [1]
    sqrt_x = ceil(sqrt(x))
    for i from 2 <= i < sqrt_x:
        if x % i == 0:
            factors.append(i)
            factors.append(x / i)
            
    if sqrt_x ** 2 == x: factors.append(sqrt_x)
    return factors

def is_perfect(int x):
    return reduce(add, _calculate_factors(x), 0) == x